diff --git a/src/main/java/net/minecraft/client/entity/particle/TerrainParticle.java b/src/main/java/net/minecraft/client/entity/particle/TerrainParticle.java
new file mode 100644
index 000000000..721c3bbb0
--- /dev/null
+++ b/src/main/java/net/minecraft/client/entity/particle/TerrainParticle.java
@@ -0,0 +1,72 @@
+package net.minecraft.client.entity.particle;
+
+import net.minecraft.client.render.LightmapHelper;
+
+// Referenced classes of package net.minecraft.src:
+//            EntityFX, Block, Tessellator, World
+
+import net.minecraft.client.render.block.color.BlockColorDispatcher;
+import net.minecraft.client.render.block.model.BlockModel;
+import net.minecraft.client.render.block.model.BlockModelDispatcher;
+import net.minecraft.client.render.tessellator.Tessellator;
+import net.minecraft.core.block.Block;
+import net.minecraft.core.util.helper.Side;
+import net.minecraft.core.world.World;
+
+public class TerrainParticle extends Particle {
+    private final Block block;
+    private final Side side;
+
+    public TerrainParticle(World world, double x, double y, double z, double xa, double ya, double za, Block block, int side, int meta)
+    {
+        super(world, x, y, z, xa, ya, za);
+        this.side = Side.getSideById(side);
+        this.block = block;
+        this.tex = BlockModelDispatcher.getInstance().getDispatch(block).getParticleTexture(this.side, meta);
+        this.gravity = block != null ? block.blockParticleGravity : 0;
+        this.rCol = this.gCol = this.bCol = 0.6F;
+        this.size /= 2.0F;
+
+    }
+
+    public TerrainParticle init(int x, int y, int z) {
+        int meta = this.world.getBlockMetadata(x, y, z);
+        BlockModel<?> model = BlockModelDispatcher.getInstance().getDispatch(this.block);
+        if (model.shouldSideBeColored(this.world, x, y, z, this.side.getId(), meta)) {
+            int col = BlockColorDispatcher.getInstance().getDispatch(this.block).getWorldColor(this.world, x, y, z);
+            this.rCol *= (col >> 16 & 0xff) / 255F;
+            this.gCol *= (col >> 8 & 0xff) / 255F;
+            this.bCol *= (col & 0xff) / 255F;
+        }
+        return this;
+    }
+
+    @Override
+	public int getParticleTexture() {
+        return 1;
+    }
+
+    @Override
+    public void render(Tessellator t, float partialTick, float xa, float ya, float za, float xa2, float za2) {
+        if (this.tex == null) return;
+        float u0 = (float) this.tex.getSubIconU(this.uo / 4F);
+        float u2 = (float) this.tex.getSubIconU(0.25f + this.uo / 4F);
+        float v0 = (float) this.tex.getSubIconV(this.uo / 4F);
+        float v2 = (float) this.tex.getSubIconV(0.25f + this.uo / 4F);
+        float r = 0.1F * this.size;
+        float x = (float)(this.xo + (this.x - this.xo) * partialTick - TerrainParticle.xOff);
+        float y = (float)(this.yo + (this.y - this.yo) * partialTick - TerrainParticle.yOff);
+        float z = (float)(this.zo + (this.z - this.zo) * partialTick - TerrainParticle.zOff);
+        float br = 1.0f;
+        if (LightmapHelper.isLightmapEnabled()) {
+        	t.setLightmapCoord(getLightmapCoord(partialTick));
+        } else {
+        	br = getBrightness(partialTick);
+        }
+        t.setColorOpaque_F(br * this.rCol, br * this.gCol, br * this.bCol);
+        t.addVertexWithUV(x - xa * r - xa2 * r, y - ya * r, z - za * r - za2 * r, u0, v2);
+        t.addVertexWithUV(x - xa * r + xa2 * r, y + ya * r, z - za * r + za2 * r, u0, v0);
+        t.addVertexWithUV(x + xa * r + xa2 * r, y + ya * r, z + za * r + za2 * r, u2, v0);
+        t.addVertexWithUV(x + xa * r - xa2 * r, y - ya * r, z + za * r - za2 * r, u2, v2);
+    }
+}
diff --git a/src/main/java/net/minecraft/client/entity/particle/WaterDropParticle.java b/src/main/java/net/minecraft/client/entity/particle/WaterDropParticle.java
new file mode 100644
index 000000000..7f7c7640f
--- /dev/null
+++ b/src/main/java/net/minecraft/client/entity/particle/WaterDropParticle.java
@@ -0,0 +1,54 @@
+package net.minecraft.client.entity.particle;
+
+import net.minecraft.client.render.texture.stitcher.TextureRegistry;
+import net.minecraft.core.block.FluidBlock;
+import net.minecraft.core.block.material.Material;
+import net.minecraft.core.util.helper.MathHelper;
+import net.minecraft.core.world.World;
+
+public class WaterDropParticle extends Particle {
+    public WaterDropParticle(World world, double x, double y, double z) {
+        super(world, x, y, z, 0.0D, 0.0D, 0.0D);
+        this.xd *= 0.3D;
+        this.yd = (float) Math.random() * 0.2F + 0.1F;
+        this.zd *= 0.3D;
+        this.rCol = 1.0F;
+        this.gCol = 1.0F;
+        this.bCol = 1.0F;
+        this.tex = TextureRegistry.getTexture("minecraft:particle/splash_rain_" + this.random.nextInt(4));
+        this.setSize(0.01F, 0.01F);
+        this.gravity = 0.06F;
+        this.lifetime = (int)(8D / (Math.random() * 0.8D + 0.2D));
+    }
+
+    @Override
+	public void tick() {
+        this.xo = this.x;
+        this.yo = this.y;
+        this.zo = this.z;
+        this.yd -= this.gravity;
+        this.move(this.xd, this.yd, this.zd);
+        this.xd *= 0.98D;
+        this.yd *= 0.98D;
+        this.zd *= 0.98D;
+        if (this.lifetime-- <= 0) {
+            this.remove();
+        }
+        if (this.onGround)
+        {
+            if (Math.random() < 0.5D) {
+                this.remove();
+            }
+            this.xd *= 0.7D;
+            this.zd *= 0.7D;
+        }
+        Material m = this.world.getBlockMaterial(MathHelper.floor(this.x), MathHelper.floor(this.y), MathHelper.floor(this.z));
+        if(m.isLiquid() || m.isSolid()) {
+            double y0 = (MathHelper.floor(this.y) + 1) - FluidBlock.getWaterVolume(this.world.getBlockMetadata(MathHelper.floor(this.x), MathHelper.floor(this.y), MathHelper.floor(this.z)));
+            if(this.y < y0)
+            {
+                remove();
+            }
+        }
+    }
+}
diff --git a/src/main/java/net/minecraft/client/entity/player/EntityPlayerSP.java b/src/main/java/net/minecraft/client/entity/player/LocalPlayer.java
similarity index 79%
rename from src/main/java/net/minecraft/client/entity/player/EntityPlayerSP.java
rename to src/main/java/net/minecraft/client/entity/player/LocalPlayer.java
index 307acfc02..95b814880 100644
--- a/src/main/java/net/minecraft/client/entity/player/EntityPlayerSP.java
+++ b/src/main/java/net/minecraft/client/entity/player/LocalPlayer.java
@@ -1,11 +1,9 @@
 package net.minecraft.client.entity.player;
 
-import java.util.List;
-
 import com.mojang.nbt.CompoundTag;
 
 import net.minecraft.client.Minecraft;
-import net.minecraft.client.entity.fx.EntityPickupFX;
+import net.minecraft.client.entity.particle.TakeAnimationParticle;
 import net.minecraft.client.gui.GuiChest;
 import net.minecraft.client.gui.GuiCrafting;
 import net.minecraft.client.gui.GuiDispenser;
@@ -19,20 +17,21 @@ import net.minecraft.client.gui.GuiTrommel;
 import net.minecraft.client.gui.GuiWandPickerMonster;
 import net.minecraft.client.input.PlayerInput;
 import net.minecraft.core.achievement.Achievement;
-import net.minecraft.core.achievement.AchievementList;
+import net.minecraft.core.achievement.Achievements;
 import net.minecraft.core.achievement.stat.Stat;
 import net.minecraft.core.achievement.stat.StatList;
+import net.minecraft.client.gui.toasts.AchievementToast;
 import net.minecraft.core.block.Block;
-import net.minecraft.core.block.BlockPortal;
-import net.minecraft.core.block.entity.TileEntityDispenser;
-import net.minecraft.core.block.entity.TileEntityFlag;
-import net.minecraft.core.block.entity.TileEntityFurnace;
-import net.minecraft.core.block.entity.TileEntityMobSpawner;
-import net.minecraft.core.block.entity.TileEntitySign;
-import net.minecraft.core.block.entity.TileEntityTrommel;
+import net.minecraft.core.block.PortalBlock;
+import net.minecraft.core.block.entity.DispenserBlockEntity;
+import net.minecraft.core.block.entity.FlagBlockEntity;
+import net.minecraft.core.block.entity.FurnaceBlockEntity;
+import net.minecraft.core.block.entity.MobSpawnerBlockEntity;
+import net.minecraft.core.block.entity.SignBlockEntity;
+import net.minecraft.core.block.entity.TrommelBlockEntity;
 import net.minecraft.core.data.gamerule.GameRules;
 import net.minecraft.core.entity.Entity;
-import net.minecraft.core.entity.player.EntityPlayer;
+import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.net.command.ClientCommandHandler;
 import net.minecraft.core.net.command.ClientPlayerCommandSender;
@@ -42,8 +41,8 @@ import net.minecraft.core.net.command.Commands;
 import net.minecraft.core.net.command.TextFormatting;
 import net.minecraft.core.player.Session;
 import net.minecraft.core.player.gamemode.Gamemode;
-import net.minecraft.core.player.inventory.ContainerPlayer;
-import net.minecraft.core.player.inventory.IInventory;
+import net.minecraft.core.player.inventory.menu.InventoryMenu;
+import net.minecraft.core.player.inventory.container.Container;
 import net.minecraft.core.sound.SoundCategory;
 import net.minecraft.core.util.helper.GetSkinUrlThread;
 import net.minecraft.core.util.helper.MathHelper;
@@ -51,23 +50,27 @@ import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.world.World;
 
 // Referenced classes of package net.minecraft.src:
-//            EntityPlayer, MouseFilter, Session, MovementInput, 
-//            AchievementList, StatFileWriter, GuiAchievement, World, 
-//            SoundManager, AxisAlignedBB, NBTTagCompound, GuiEditSign, 
+//            Player, MouseFilter, Session, MovementInput,
+//            Achievements, StatFileWriter, GuiHudToasts, World,
+//            SoundEngine, AxisAlignedBB, NBTTagCompound, GuiEditSign,
 //            GuiChest, GuiCrafting, GuiFurnace, GuiDispenser, 
 //            EntityPickupFX, EffectRenderer, InventoryPlayer, GuiIngame, 
-//            StatBase, Achievement, MathHelper, TileEntitySign, 
-//            IInventory, TileEntityFurnace, TileEntityDispenser, Entity
+//            StatBase, Achievement, MathHelper, SignBlockEntity,
+//            IInventory, FurnaceBlockEntity, DispenserBlockEntity, Entity
 
-public class EntityPlayerSP extends EntityPlayer
+public class LocalPlayer extends Player
 {
+    public PlayerInput input;
+    protected Minecraft mc;
+    public final ClientPlayerCommandSender sender;
+    protected int sprintTimer;
 
-    public EntityPlayerSP(Minecraft minecraft, World world, Session session, int i)
+    public LocalPlayer(Minecraft minecraft, World world, Session session, int dimension)
     {
         super(world);
         mc = minecraft;
         sender = new ClientPlayerCommandSender(minecraft, this);
-        dimension = i;
+        this.dimension = dimension;
         username = session.username;
         
         new GetSkinUrlThread(this);
@@ -96,9 +99,9 @@ public class EntityPlayerSP extends EntityPlayer
     }
 
     @Override
-    public void updatePlayerActionState()
+    public void updateAI()
     {
-        super.updatePlayerActionState();
+        super.updateAI();
         moveStrafing = input.moveStrafe;
         moveForward = input.moveForward;
         isJumping = input.jump;
@@ -109,7 +112,7 @@ public class EntityPlayerSP extends EntityPlayer
     {
         this.gamemode = gamemode;
 
-        ContainerPlayer newContainer = gamemode.getContainer(this.inventory, !world.isClientSide);
+        InventoryMenu newContainer = gamemode.getContainer(this.inventory, !world.isClientSide);
         if (craftingInventory == inventorySlots)
         {
             craftingInventory = newContainer;
@@ -131,19 +134,20 @@ public class EntityPlayerSP extends EntityPlayer
             sprintTimer--;
         }
 
-        if (!this.mc.statsCounter.isAchievementUnlocked(AchievementList.OPEN_INVENTORY) &&
-                !this.mc.guiAchievement.isDisplayingAchievement(AchievementList.OPEN_INVENTORY)
-        )
+        AchievementToast invToast = new AchievementToast(Achievements.OPEN_INVENTORY, true);
+        AchievementToast guideToast = new AchievementToast(Achievements.OPEN_GUIDEBOOK, true);
+
+        if (!this.mc.statsCounter.isUnlocked(Achievements.OPEN_INVENTORY) && !this.mc.guiAchievementToast.isDisplayingToast(invToast))
         {
-            this.mc.guiAchievement.queueAchievementInformation(AchievementList.OPEN_INVENTORY);
+            this.mc.guiAchievementToast.addToast(invToast);
         }
-        if (this.mc.statsCounter.isAchievementUnlocked(AchievementList.OPEN_INVENTORY) &&
-                !this.mc.statsCounter.isAchievementUnlocked(AchievementList.OPEN_GUIDEBOOK) &&
-                !this.mc.guiAchievement.isDisplayingAchievement(AchievementList.OPEN_INVENTORY) &&
-                !this.mc.guiAchievement.isDisplayingAchievement(AchievementList.OPEN_GUIDEBOOK)
+        if (/*this.mc.statsCounter.isUnlocked(Achievements.OPEN_INVENTORY) &&*/
+                !this.mc.statsCounter.isUnlocked(Achievements.OPEN_GUIDEBOOK) &&
+//                !this.mc.guiAchievementToast.isDisplayingToast(invToast) &&
+                !this.mc.guiAchievementToast.isDisplayingToast(guideToast)
         )
         {
-            this.mc.guiAchievement.queueAchievementInformation(AchievementList.OPEN_GUIDEBOOK);
+            this.mc.guiAchievementToast.addToast(guideToast);
         }
 
         prevTimeInPortal = timeInPortal;
@@ -169,7 +173,7 @@ public class EntityPlayerSP extends EntityPlayer
                 {
                     timeUntilPortal = 10;
                     mc.sndManager.playSound("portal.travel", SoundCategory.WORLD_SOUNDS, 1.0F, random.nextFloat() * 0.4F + 0.8F);
-                    int targetDim = ((BlockPortal) Block.blocksList[portalID]).targetDimension;
+                    int targetDim = ((PortalBlock) Block.blocksList[portalID]).targetDimension;
                     if (dimension == targetDim)
                     {
                         mc.usePortal(0);
@@ -264,19 +268,19 @@ public class EntityPlayerSP extends EntityPlayer
     }
 
     @Override
-    public void displayGUIEditSign(TileEntitySign tileentitysign)
+    public void displayGUIEditSign(SignBlockEntity tileentitysign)
     {
         mc.displayGuiScreen(new GuiEditSign(tileentitysign));
     }
 
     @Override
-    public void displayGUIEditFlag(TileEntityFlag tileEntityFlag)
+    public void displayGUIEditFlag(FlagBlockEntity tileEntityFlag)
     {
         mc.displayGuiScreen(new GuiEditFlag(this, tileEntityFlag));
     }
 
     @Override
-    public void displayGUIChest(IInventory iinventory)
+    public void displayGUIChest(Container iinventory)
     {
         mc.displayGuiScreen(new GuiChest(inventory, iinventory));
     }
@@ -301,7 +305,7 @@ public class EntityPlayerSP extends EntityPlayer
 
     @Override
     public void displayGUIMobSpawnerPicker(int x, int y, int z) {
-        String currentMobId = ((TileEntityMobSpawner) world.getBlockTileEntity(x, y, z)).getMobId();
+        String currentMobId = ((MobSpawnerBlockEntity) world.getBlockEntity(x, y, z)).getMobId();
         mc.displayGuiScreen(new GuiPickMonster(currentMobId, x, y, z));
     }
     @Override
@@ -311,19 +315,19 @@ public class EntityPlayerSP extends EntityPlayer
     }
 
     @Override
-    public void displayGUIFurnace(TileEntityFurnace tileentityfurnace)
+    public void displayGUIFurnace(FurnaceBlockEntity tileentityfurnace)
     {
         mc.displayGuiScreen(new GuiFurnace(inventory, tileentityfurnace));
     }
 
     @Override
-    public void displayGUITrommel(TileEntityTrommel tileEntityTrommel)
+    public void displayGUITrommel(TrommelBlockEntity tileEntityTrommel)
     {
         mc.displayGuiScreen(new GuiTrommel(inventory, tileEntityTrommel));
     }
 
     @Override
-    public void displayGUIDispenser(TileEntityDispenser tileentitydispenser)
+    public void displayGUIDispenser(DispenserBlockEntity tileentitydispenser)
     {
         mc.displayGuiScreen(new GuiDispenser(inventory, tileentitydispenser));
     }
@@ -335,10 +339,10 @@ public class EntityPlayerSP extends EntityPlayer
     }
 
     @Override
-    public void onItemPickup(Entity entity, int i)
+    public void onItemPickup(Entity entity, ItemStack item)
     {
-        addStat(StatList.pickUpItemStats[i], 1);
-        mc.effectRenderer.addEffect(new EntityPickupFX(mc.theWorld, entity, this, -0.5F));
+        addStat(item.getItem().getStat(StatList.STAT_PICKED_UP), 1);
+        mc.effectRenderer.addEffect(new TakeAnimationParticle(mc.theWorld, entity, this, -0.5F));
     }
 
     public int getPlayerProtectionAmount()
@@ -436,26 +440,24 @@ public class EntityPlayerSP extends EntityPlayer
     }
     
     @Override
-    public void addStat(Stat statbase, int i)
+    public void addStat(Stat stat, int i)
     {
-        if(statbase == null)
-        {
+        if(stat == null) {
             return;
         }
-        if(statbase.isAchievement())
-        {
-            Achievement achievement = (Achievement)statbase;
-            if(achievement.parent == null || mc.statsCounter.isAchievementUnlocked(achievement.parent))
+        if(stat.isAchievement()) {
+            Achievement achievement = (Achievement)stat;
+            if(achievement.parent == null || mc.statsCounter.isUnlocked(achievement.parent))
             {
-                if(!mc.statsCounter.isAchievementUnlocked(achievement))
+                if(!mc.statsCounter.isUnlocked(achievement))
                 {
-                    mc.guiAchievement.queueTakenAchievement(achievement);
+                    mc.guiAchievementToast.addToast(new AchievementToast(achievement, false));
                 }
-                mc.statsCounter.addValueToStat(statbase, i);
+                mc.statsCounter.add(stat, i);
             }
         } else
         {
-            mc.statsCounter.addValueToStat(statbase, i);
+            mc.statsCounter.add(stat, i);
         }
     }
     
@@ -474,9 +476,9 @@ public class EntityPlayerSP extends EntityPlayer
     protected boolean checkInTile(double d, double d1, double d2)
     {
         if (noPhysics) return false;
-        int i = MathHelper.floor_double(d);
-        int j = MathHelper.floor_double(d1);
-        int k = MathHelper.floor_double(d2);
+        int i = MathHelper.floor(d);
+        int j = MathHelper.floor(d1);
+        int k = MathHelper.floor(d2);
         double d3 = d - (double)i;
         double d4 = d2 - (double)k;
         if(isBlockTranslucent(i, j, k) || (isBlockTranslucent(i, j + 1, k) && !isDwarf))
@@ -542,9 +544,4 @@ public class EntityPlayerSP extends EntityPlayer
 		mc.ingameGUI.guiHeldItemTooltip.setString(message);
 	}
 
-    public PlayerInput input;
-    protected Minecraft mc;
-    protected List<Command> allowedCommands;
-    public final ClientPlayerCommandSender sender;
-    protected int sprintTimer;
 }
diff --git a/src/main/java/net/minecraft/client/entity/player/MultiplayerLocalPlayer.java b/src/main/java/net/minecraft/client/entity/player/MultiplayerLocalPlayer.java
new file mode 100644
index 000000000..66adcb25e
--- /dev/null
+++ b/src/main/java/net/minecraft/client/entity/player/MultiplayerLocalPlayer.java
@@ -0,0 +1,277 @@
+package net.minecraft.client.entity.player;
+
+import net.minecraft.client.Minecraft;
+import net.minecraft.client.gui.guidebook.GuiGuidebook;
+import net.minecraft.client.net.handler.ClientPacketHandler;
+import net.minecraft.core.achievement.stat.Stat;
+import net.minecraft.core.data.registry.Registries;
+import net.minecraft.core.entity.Entity;
+import net.minecraft.core.entity.ItemEntity;
+import net.minecraft.core.net.packet.ChatPacket;
+import net.minecraft.core.net.packet.PlayerCommandPacket;
+import net.minecraft.core.net.packet.MovePlayerPacket;
+import net.minecraft.core.net.packet.ContainerClosePacket;
+import net.minecraft.core.net.packet.UpdateCreativeInventoryPacket;
+import net.minecraft.core.net.packet.SetHotbarOffsetPacket;
+import net.minecraft.core.net.packet.GuidebookPacket;
+import net.minecraft.core.net.packet.PlayerActionPacket;
+import net.minecraft.core.net.packet.AnimatePacket;
+import net.minecraft.core.net.packet.CustomPayloadPacket;
+import net.minecraft.core.net.packet.RespawnPacket;
+import net.minecraft.core.player.Session;
+import net.minecraft.core.util.helper.AES;
+import net.minecraft.core.util.helper.DamageType;
+import net.minecraft.core.util.helper.MathHelper;
+import net.minecraft.core.util.helper.Side;
+import net.minecraft.core.world.World;
+public class MultiplayerLocalPlayer extends LocalPlayer
+{
+    public ClientPacketHandler sendQueue;
+    private int lastInventorySendTime;
+    private boolean flashOnSetHealth;
+    private double oldPosX;
+    private double oldPosY1;
+    private double oldPosY2;
+    private double oldPosZ;
+    private float oldRotationYaw;
+    private float oldRotationPitch;
+    private boolean wasOnGround;
+    private boolean wasSneaking;
+    private int noSendTime;
+
+    public MultiplayerLocalPlayer(Minecraft minecraft, World world, Session session, ClientPacketHandler netclienthandler)
+    {
+        super(minecraft, world, session, 0);
+        lastInventorySendTime = 0;
+        flashOnSetHealth = false;
+        wasOnGround = false;
+        wasSneaking = false;
+        noSendTime = 0;
+        sendQueue = netclienthandler;
+    }
+
+    @Override
+    public boolean hurt(Entity attacker, int i, DamageType type)
+    {
+        return false;
+    }
+
+    @Override
+	public void heal(int i)
+    {
+    }
+
+    @Override
+	public void tick()
+    {
+        if(!world.isBlockLoaded(MathHelper.floor(x), 64, MathHelper.floor(z)))
+        {
+            return;
+        } else
+        {
+            super.tick();
+            sendPosition();
+            return;
+        }
+    }
+
+    public void sendPosition()
+    {
+        if(lastInventorySendTime++ == 20)
+        {
+            sendInventoryChanged();
+            lastInventorySendTime = 0;
+        }
+        boolean flag = isSneaking();
+        if(flag != wasSneaking)
+        {
+            if(flag)
+            {
+                sendQueue.addToSendQueue(new PlayerCommandPacket(this, 1));
+            } else
+            {
+                sendQueue.addToSendQueue(new PlayerCommandPacket(this, 2));
+            }
+            wasSneaking = flag;
+        }
+        double d = x - oldPosX;
+        double d1 = bb.minY - oldPosY1;
+        double d2 = y - oldPosY2;
+        double d3 = z - oldPosZ;
+        double d4 = yRot - oldRotationYaw;
+        double d5 = xRot - oldRotationPitch;
+        boolean flag1 = d1 != 0.0D || d2 != 0.0D || d != 0.0D || d3 != 0.0D;
+        boolean flag2 = d4 != 0.0D || d5 != 0.0D;
+        if(vehicle != null)
+        {
+            if(flag2)
+            {
+                sendQueue.addToSendQueue(new MovePlayerPacket.Pos(xd, -999D, -999D, zd, onGround));
+            } else
+            {
+                sendQueue.addToSendQueue(new MovePlayerPacket.PosRot(xd, -999D, -999D, zd, yRot, xRot, onGround));
+            }
+            flag1 = false;
+        } else
+        if(flag1 && flag2)
+        {
+            sendQueue.addToSendQueue(new MovePlayerPacket.PosRot(x, bb.minY, y, z, yRot, xRot, onGround));
+            noSendTime = 0;
+        } else
+        if(flag1)
+        {
+            sendQueue.addToSendQueue(new MovePlayerPacket.Pos(x, bb.minY, y, z, onGround));
+            noSendTime = 0;
+        } else
+        if(flag2)
+        {
+            sendQueue.addToSendQueue(new MovePlayerPacket.Rot(yRot, xRot, onGround));
+            noSendTime = 0;
+        } else
+        {
+            sendQueue.addToSendQueue(new MovePlayerPacket(onGround));
+            if(wasOnGround != onGround || noSendTime > 200)
+            {
+                noSendTime = 0;
+            } else
+            {
+                noSendTime++;
+            }
+        }
+        wasOnGround = onGround;
+        if(flag1)
+        {
+            oldPosX = x;
+            oldPosY1 = bb.minY;
+            oldPosY2 = y;
+            oldPosZ = z;
+        }
+        if(flag2)
+        {
+            oldRotationYaw = yRot;
+            oldRotationPitch = xRot;
+        }
+    }
+
+    @Override
+    public void dropCurrentItem(boolean dropFullStack) {
+        sendQueue.addToSendQueue(new PlayerActionPacket(dropFullStack ? 5 : 4, 0, 0, 0, Side.NONE, 0.0, 0.0));
+    }
+
+    private void sendInventoryChanged()
+    {
+    }
+
+    @Override
+	protected void joinEntityItemWithWorld(ItemEntity entityitem)
+    {
+    }
+
+    @Override
+	public void sendChatMessage(String s)
+    {
+        sendQueue.addToSendQueue(new ChatPacket(s, AES.clientKeyChain));
+    	addToSendHistory(s);
+    }
+    
+    @Override
+	public void updateCreativeInventory(int page, String searchText)
+    {
+    	sendQueue.addToSendQueue(new UpdateCreativeInventoryPacket(craftingInventory.containerId, page, searchText));
+    }
+
+    @Override
+    public void setHotbarOffset(int offset)
+    {
+        super.setHotbarOffset(offset);
+        sendQueue.addToSendQueue(new SetHotbarOffsetPacket(offset));
+    }
+
+    @Override
+	public void displayGUIGuidebook()
+    {
+        mc.displayGuiScreen(new GuiGuidebook());
+        sendQueue.addToSendQueue(new GuidebookPacket(mc.currentScreen instanceof GuiGuidebook));
+    }
+
+    @Override
+	public void swingItem()
+    {
+        super.swingItem();
+        sendQueue.addToSendQueue(new AnimatePacket(this, 1));
+    }
+
+    @Override
+	public void respawnPlayer()
+    {
+        sendInventoryChanged();
+        sendQueue.addToSendQueue(new RespawnPacket((byte)dimension, (byte) Registries.WORLD_TYPES.getNumericIdOfItem(world.worldType)));
+    }
+
+    @Override
+	protected void damageEntity(int i, DamageType damageType)
+    {
+        setHealthRaw(getHealth() - i);
+    }
+
+    @Override
+	public void closeScreen()
+    {
+        sendQueue.addToSendQueue(new ContainerClosePacket(craftingInventory.containerId));
+        inventory.setHeldItemStack(null);
+        super.closeScreen();
+    }
+
+    @Override
+	public void setHealth(int i)
+    {
+        if(flashOnSetHealth)
+        {
+            super.setHealth(i);
+        } else
+        {
+            setHealthRaw(i);
+            flashOnSetHealth = true;
+        }
+    }
+
+    @Override
+	public void addStat(Stat stat, int i)
+    {
+        if(stat == null) {
+            return;
+        }
+        if(stat.clientside)
+        {
+            super.addStat(stat, i);
+        }
+    }
+    
+    @Override
+	public int getStat(Stat statbase)
+    {
+    	if (statbase.clientside)
+    	{
+    		return super.getStat(statbase);
+    	}
+    	return 0;
+    }
+    
+    @Override
+	public void syncPlacementMode() {
+    	super.syncPlacementMode();
+    	
+    	byte[] data = new byte[4];
+    	data[0] = (byte) (rotationLock != null ? rotationLock.getId() : -1);
+    	data[1] = (byte) (rotationLockHorizontal != null ? rotationLockHorizontal.getId() : -1);
+    	data[2] = (byte) (rotationLockVertical != null ? rotationLockVertical.getId() : -1);
+    	data[3] = (byte) (placementModeOverride != null ? placementModeOverride.index() : -1);
+    	
+    	sendQueue.addToSendQueue(new CustomPayloadPacket("BTA|RotationLock", data));
+    }
+    
+    @Override
+    public void pickBlock(int x, int y, int z) {
+    	sendQueue.addToSendQueue(new PlayerActionPacket(6, x, y, z, Side.NONE, 0.0, 0.0));
+    }
+}
